com.google.cloud.dataflow.sdk

## Interface Pipeline.PipelineVisitor

All Known Implementing Classes:
  RecordingPipelineVisitor

Enclosing class:
  Pipeline

    public static interface Pipeline.PipelineVisitor

A `Pipeline.PipelineVisitor` can be passed into `Pipeline.traverseTopologically(com.google.cloud.dataflow.sdk.Pipeline.PipelineVisitor)` to be called for each of the transforms and values in the `Pipeline`.

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `enterCompositeTransform(TransformTreeNode node)` Called for each composite transform after all topological predecessors have been visited but before any of its component transforms.
`void` `leaveCompositeTransform(TransformTreeNode node)` Called for each composite transform after all of its component transforms and their outputs have been visited.
`void` `visitTransform(TransformTreeNode node)` Called for each primitive transform after all of its topological predecessors and inputs have been visited.
`void` `visitValue(PValue value, TransformTreeNode producer)` Called for each value after the transform that produced the value has been visited.

### Method Detail

#### enterCompositeTransform

    void enterCompositeTransform(TransformTreeNode node)

Called for each composite transform after all topological predecessors have been visited but before any of its component transforms.

#### leaveCompositeTransform

    void leaveCompositeTransform(TransformTreeNode node)

Called for each composite transform after all of its component transforms and their outputs have been visited.

#### visitTransform

    void visitTransform(TransformTreeNode node)

Called for each primitive transform after all of its topological predecessors and inputs have been visited.

#### visitValue

    void visitValue(PValue value,
                    TransformTreeNode producer)

Called for each value after the transform that produced the value has been visited.